
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java集合---LinkedList源码解析 / 憋错料</title>

    <meta name="description" content="Java集合---LinkedList源码解析 一.源码解析1. LinkedList类定义2.LinkedList数据结构原理3.私有属性4.构造方法5.元素添加add()及原理6.删除数据remove()7.数据获取get()8.数据复制clone()与toArray()9.遍历数据:Iterator()二.ListItr 一.源码解析 1. LinkedList类定义. public class LinkedList&lt;E&gt; extends AbstractSequentialList&lt;E&gt; implements  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java集合---LinkedList源码解析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>一、源码解析<br />1、 LinkedList类定义<br />2、LinkedList数据结构原理<br />3、私有属性<br />4、构造方法<br />5、元素添加add()及原理<br />6、删除数据remove()<br />7、数据获取get()<br />8、数据复制clone()与toArray()<br />9、遍历数据：Iterator()<br />二、ListItr</p>
<p>一、源码解析</p>
<p>1、&nbsp;LinkedList类定义。</p>
<pre>public class LinkedList&lt;E&gt;
     extends AbstractSequentialList&lt;E&gt;
     implements List&lt;E&gt;, Deque&lt;E&gt;, Cloneable, java.io.Serializable</pre>
<p>LinkedList&nbsp;是一个继承于AbstractSequentialList的双向链表。它也可以被当作堆栈、队列或双端队列进行操作。<br />LinkedList&nbsp;实现&nbsp;List&nbsp;接口，能对它进行队列操作。<br />LinkedList&nbsp;实现&nbsp;Deque&nbsp;接口，即能将LinkedList当作双端队列使用。<br />LinkedList&nbsp;实现了Cloneable接口，即覆盖了函数clone()，能克隆。<br />LinkedList&nbsp;实现java.io.Serializable接口，这意味着LinkedList支持序列化，能通过序列化去传输。<br />LinkedList&nbsp;是非同步的。</p>
<p>为什么要继承自AbstractSequentialList ?</p>
<p>AbstractSequentialList&nbsp;实现了get(int index)、set(int index, E element)、add(int index, E element) 和 remove(int index)这些骨干性函数。降低了List接口的复杂度。<strong>这些接口都是随机访问List的</strong>，LinkedList是双向链表；既然它继承于AbstractSequentialList，就相当于已经实现了“get(int index)这些接口”。</p>
<p>此外，我们若需要通过AbstractSequentialList自己实现一个列表，只需要扩展此类，并提供 listIterator() 和 size() 方法的实现即可。若要实现不可修改的列表，则需要实现列表迭代器的 hasNext、next、hasPrevious、previous 和 index 方法即可。</p>
<p>LinkedList的类图关系：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwMDgyNy8yMDE0MDkvMDUwMDUzNDM0Njk3NDM5LnBuZw==.jpg"></p>
<p>2、LinkedList数据结构原理</p>
<p>LinkedList底层的数据结构是基于双向循环链表的，且头结点中不存放数据,如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwMDgyNy8yMDE0MDkvMDUwMTUzMDEwMTYzOTIyLmpwZw==.jpg"></p>
<p>既然是双向链表，那么必定存在一种数据结构——我们可以称之为节点，节点实例保存业务数据，前一个节点的位置信息和后一个节点位置信息，如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwMDgyNy8yMDE0MDkvMDUwMTAxMzIxMjU1MjYyLnBuZw==.jpg"></p>
<p>3、私有属性</p>
<p>LinkedList中之定义了两个属性：</p>
<pre>1 private transient Entry&lt;E&gt; header = new Entry&lt;E&gt;(null, null, null);
2 private transient int size = 0;</pre>
<p>header是双向链表的头节点，它是双向链表节点所对应的类Entry的实例。Entry中包含成员变量： previous, next, element。其中，previous是该节点的上一个节点，next是该节点的下一个节点，element是该节点所包含的值。&nbsp;<br />　　size是双向链表中节点实例的个数。</p>
<p>首先来了解节点类Entry类的代码。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre>1 private static class Entry&lt;E&gt; {
 2    E element;
 3     Entry&lt;E&gt; next;
 4     Entry&lt;E&gt; previous;
 5
 6     Entry(E element, Entry&lt;E&gt; next, Entry&lt;E&gt; previous) {
 7         this.element = element;
 8         this.next = next;
 9         this.previous = previous;
10    }
11 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>节点类很简单，element存放业务数据，previous与next分别存放前后节点的信息（在数据结构中我们通常称之为前后节点的指针）。</p>
<p>LinkedList的构造方法:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre>1 public LinkedList() {
2     header.next = header.previous = header;
3 }
4 public LinkedList(Collection&lt;? extends E&gt; c) {
5     this();
6    addAll(c);
7 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>4、构造方法</p>
<p>LinkedList提供了两个构造方法。</p>
<p>第一个构造方法不接受参数，将header实例的previous和next全部指向header实例（注意，这个是一个双向循环链表，如果不是循环链表，空链表的情况应该是header节点的前一节点和后一节点均为null），这样整个链表其实就只有header一个节点，用于表示一个空的链表。</p>
<p>执行完构造函数后，header实例自身形成一个闭环，如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwMDgyNy8yMDE0MDkvMDUwMTA0NTk4MTM5NDc5LnBuZw==.jpg"></p>
<p>第二个构造方法接收一个Collection参数c，调用第一个构造方法构造一个空的链表，之后通过addAll将c中的元素全部添加到链表中。</p>
<p>5、元素添加</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre> 1 public boolean addAll(Collection&lt;? extends E&gt; c) {
 2     return addAll(size, c);
 3 }
 4 // index参数指定collection中插入的第一个元素的位置
  5 public boolean addAll(int index, Collection&lt;? extends E&gt; c) {
 6     // 插入位置超过了链表的长度或小于0，报IndexOutOfBoundsException异常
  7     if (index &lt; 0 || index &gt; size)
 8         throw new IndexOutOfBoundsException("Index: "+index+
  9                                                 ", Size: "+size);
10     Object[] a = c.toArray();
11    int numNew = a.length;
12    // 若需要插入的节点个数为0则返回false，表示没有插入元素
13     if (numNew==0)
14         return false;
15     modCount++;//否则，插入对象，链表修改次数加1
16     // 保存index处的节点。插入位置如果是size，则在头结点前面插入，否则在获取index处的节点插入
17     Entry&lt;E&gt; successor = (index==size ? header : entry(index));
18     // 获取前一个节点，插入时需要修改这个节点的next引用
19     Entry&lt;E&gt; predecessor = successor.previous;
20     // 按顺序将a数组中的第一个元素插入到index处，将之后的元素插在这个元素后面
21     for (int i=0; i&lt;numNew; i++) {
22         // 结合Entry的构造方法，这条语句是插入操作，相当于C语言中链表中插入节点并修改指针
23         Entry&lt;E&gt; e = new Entry&lt;E&gt;((E)a[i], successor, predecessor);
24         // 插入节点后将前一节点的next指向当前节点，相当于修改前一节点的next指针
25         predecessor.next = e;
26         // 相当于C语言中成功插入元素后将指针向后移动一个位置以实现循环的功能
27         predecessor = e;
28   }
29     // 插入元素前index处的元素链接到插入的Collection的最后一个节点
30     successor.previous = predecessor;
31     // 修改size
32     size += numNew;
33     return true;
34 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>构造方法中的调用了addAll(Collection&lt;?&nbsp;extends&nbsp;E&gt;&nbsp;c)方法，而在addAll(Collection&lt;?&nbsp;extends&nbsp;E&gt;&nbsp;c)方法中仅仅是将size当做index参数调用了addAll(int&nbsp;index,Collection&lt;?&nbsp;extends&nbsp;E&gt;&nbsp;c)方法。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre>1 private Entry&lt;E&gt; entry(int index) {
 2         if (index &lt; 0 || index &gt;= size)
 3             throw new IndexOutOfBoundsException("Index: "+index+
 4                                                 ", Size: "+size);
 5         Entry&lt;E&gt; e = header;
 6         // 根据这个判断决定从哪个方向遍历这个链表
 7         if (index &lt; (size &gt;&gt; 1)) {
 8             for (int i = 0; i &lt;= index; i++)
 9                 e = e.next;
10         } else {
11             // 可以通过header节点向前遍历，说明这个一个循环双向链表，header的previous指向链表的最后一个节点，这也验证了构造方法中对于header节点的前后节点均指向自己的解释
12             for (int i = size; i &gt; index; i--)
13                 e = e.previous;
14        }
15         return e;
16     }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>下面说明双向链表添加元素的原理:</p>
<p><strong>添加数据：add()</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre>     // 将元素(E)添加到LinkedList中
     public boolean add(E e) {
         // 将节点(节点数据是e)添加到表头(header)之前。
         // 即，将节点添加到双向链表的末端。
         addBefore(e, header);
         return true;
     }

     public void add(int index, E element) {
         addBefore(element, (index==size ? header : entry(index)));
     }

    private Entry&lt;E&gt; addBefore(E e, Entry&lt;E&gt; entry) {
         Entry&lt;E&gt; newEntry = new Entry&lt;E&gt;(e, entry, entry.previous);
         newEntry.previous.next = newEntry;
         newEntry.next.previous = newEntry;
         size++;
         modCount++;
         return newEntry;
    }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>addBefore(E e,Entry&lt;E&gt; entry)方法是个私有方法，所以无法在外部程序中调用（当然，这是一般情况，你可以通过反射上面的还是能调用到的）。</p>
<p>addBefore(E e,Entry&lt;E&gt; entry)先通过Entry的构造方法创建e的节点newEntry（包含了将其下一个节点设置为entry，上一个节点设置为entry.previous的操作，相当于修改newEntry的“指针”），之后修改插入位置后newEntry的前一节点的next引用和后一节点的previous引用，使链表节点间的引用关系保持正确。之后修改和size大小和记录modCount，然后返回新插入的节点。</p>
<p>下面分解“添加第一个数据”的步骤：</p>
<p>第一步：初始化后LinkedList实例的情况：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwMDgyNy8yMDE0MDkvMDUwMTI3NDAxNzI5MjgxLnBuZw==.jpg"></p>
<p>第二步：初始化一个预添加的Entry实例（newEntry）。</p>
<p><strong>Entry newEntry = newEntry(e, entry, entry.previous);</strong></p>
<p><em><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwMDgyNy8yMDE0MDkvMDUwMTI4MjY1NDc0NTQ3LnBuZw==.jpg"></em></p>
<p>第三步：调整新加入节点和头结点（header）的前后指针。</p>
<p><strong>newEntry.previous.next = newEntry;</strong></p>
<p>newEntry.previous即header，newEntry.previous.next即header的next指向newEntry实例。在上图中应该是“4号线”指向newEntry。</p>
<p><strong>newEntry.next.previous = newEntry;</strong></p>
<p>newEntry.next即header，newEntry.next.previous即header的previous指向newEntry实例。在上图中应该是“3号线”指向newEntry。</p>
<p>调整后如下图所示：</p>
<p>图——加入第一个节点后LinkedList示意图</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwMDgyNy8yMDE0MDkvMDUwMTI5NDgwNzgzMjcyLnBuZw==.jpg"></p>
<p>下面分解“添加第二个数据”的步骤：</p>
<p>第一步：新建节点。</p>
<p>图——添加第二个节点</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwMDgyNy8yMDE0MDkvMDUwMTMwNTE3MTk5Mjk2LnBuZw==.jpg"></p>
<p>第二步：调整新节点和头结点的前后指针信息。</p>
<p>图——调整前后指针信息</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwMDgyNy8yMDE0MDkvMDUwMTMxMjA3MzUxODMxLnBuZw==.jpg"></p>
<p>添加后续数据情况和上述一致，LinkedList实例是没有容量限制的。</p>
<p>总结，addBefore(E e,Entry&lt;E&gt; entry)实现在entry之前插入由e构造的新节点。而add(E e)实现在header节点之前插入由e构造的新节点。为了便于理解，下面给出插入节点的示意图。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzQwMDgyNy8yMDE0MDkvMDUwMTI0MTA0Mzg2MTI0LmpwZw==.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre> public void addFirst(E e) {
     addBefore(e, header.next);
 }

 public void addLast(E e) {
     addBefore(e, header);
 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>看上面的示意图，结合addBefore(E e,Entry&lt;E&gt; entry)方法，很容易理解addFrist(E e)只需实现在header元素的下一个元素之前插入，即示意图中的一号之前。addLast(E e)只需在实现在header节点前（因为是循环链表，所以header的前一个节点就是链表的最后一个节点）插入节点（插入后在2号节点之后）。</p>
<p>清除数据clear()</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre> 1 public void clear() {
 2     Entry&lt;E&gt; e = header.next;
 3     // e可以理解为一个移动的“指针”，因为是循环链表，所以回到header的时候说明已经没有节点了
 4      while (e != header) {
 5        // 保留e的下一个节点的引用
 6         Entry&lt;E&gt; next = e.next;
 7         // 解除节点e对前后节点的引用
 8         e.next = e.previous = null;
 9         // 将节点e的内容置空
10         e.element = null;
11         // 将e移动到下一个节点
12         e = next;
13  }
14     // 将header构造成一个循环链表，同构造方法构造一个空的LinkedList
15     header.next = header.previous = header;
16     // 修改size
17     size = 0;
18     modCount++;
19 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>数据包含 contains(Object&nbsp;o)</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre> public boolean contains(Object o) {
     return indexOf(o) != -1;
 }
 // 从前向后查找，返回“值为对象(o)的节点对应的索引”  不存在就返回-1
 public int indexOf(Object o) {
      int index = 0;
      if (o==null) {
          for (Entry e = header.next; e != header; e = e.next) {
              if (e.element==null)
                  return index;
              index++;
         }
      } else {
         for (Entry e = header.next; e != header; e = e.next) {
             if (o.equals(e.element))
                 return index;
             index++;
        }
    }
     return -1;
 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>indexOf(Object&nbsp;o)判断o链表中是否存在节点的element和o相等，若相等则返回该节点在链表中的索引位置，若不存在则放回-1。</p>
<p>contains(Object&nbsp;o)方法通过判断indexOf(Object&nbsp;o)方法返回的值是否是-1来判断链表中是否包含对象o。</p>
<p>6、删除数据remove()</p>
<p>几个remove方法最终都是调用了一个私有方法：remove(Entry&lt;E&gt;&nbsp;e)，只是其他简单逻辑上的区别。下面分析remove(Entry&lt;E&gt;&nbsp;e)方法。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre> 1 private E remove(Entry&lt;E&gt; e) {
 2     if (e == header)
 3         throw new NoSuchElementException();
 4     // 保留将被移除的节点e的内容
 5     E result = e.element;
 6    // 将前一节点的next引用赋值为e的下一节点
 7     e.previous.next = e.next;
 8    // 将e的下一节点的previous赋值为e的上一节点
 9     e.next.previous = e.previous;
10    // 上面两条语句的执行已经导致了无法在链表中访问到e节点，而下面解除了e节点对前后节点的引用
11    e.next = e.previous = null;
12   // 将被移除的节点的内容设为null
13   e.element = null;
14   // 修改size大小
15   size--;
16   modCount++;
17   // 返回移除节点e的内容
18   return result;
19 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>由于删除了某一节点因此调整相应节点的前后指针信息，如下：</p>
<p><strong>e.previous.next = e.next;//预删除节点的前一节点的后指针指向预删除节点的后一个节点。&nbsp;</strong></p>
<p><strong>e.next.previous = e.previous;//预删除节点的后一节点的前指针指向预删除节点的前一个节点。&nbsp;</strong></p>
<p>清空预删除节点：</p>
<p><strong>e.next = e.previous = null;</strong></p>
<p><strong>e.element = null;</strong></p>
<p>交给gc完成资源回收，删除操作结束。</p>
<p>与ArrayList比较而言，LinkedList的删除动作不需要“移动”很多数据，从而效率更高。</p>
<p>7、数据获取get()</p>
<p>Get(int)方法的实现在remove(int)中已经涉及过了。首先判断位置信息是否合法（大于等于0，小于当前LinkedList实例的Size），然后遍历到具体位置，获得节点的业务数据（element）并返回。</p>
<p>注意：为了提高效率，需要根据获取的位置判断是从头还是从尾开始遍历。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre>// 获取双向链表中指定位置的节点
    private Entry&lt;E&gt; entry(int index) {
        if (index &lt; 0 || index &gt;= size)
            throw new IndexOutOfBoundsException("Index: "+index+
                                                ", Size: "+size);
        Entry&lt;E&gt; e = header;
        // 获取index处的节点。
        // 若index &lt; 双向链表长度的1/2,则从前先后查找;
        // 否则，从后向前查找。
        if (index &lt; (size &gt;&gt; 1)) {
            for (int i = 0; i &lt;= index; i++)
                e = e.next;
        } else {
            for (int i = size; i &gt; index; i--)
                e = e.previous;
        }
        return e;
    }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>注意细节：位运算与直接做除法的区别。先将index与长度size的一半比较，如果index&lt;size/2，就只从位置0往后遍历到位置index处，而如果index&gt;size/2，就只从位置size往前遍历到位置index处。这样可以减少一部分不必要的遍历</p>
<p>8、数据复制clone()与toArray()</p>
<p>clone()</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre> 1 public Object clone() {
 2     LinkedList&lt;E&gt; clone = null;
 3     try {
 4         clone = (LinkedList&lt;E&gt;) super.clone();
 5     } catch (CloneNotSupportedException e) {
 6         throw new InternalError();
 7    }
 8     clone.header = new Entry&lt;E&gt;(null, null, null);
 9     clone.header.next = clone.header.previous = clone.header;
10     clone.size = 0;
11     clone.modCount = 0;
12     for (Entry&lt;E&gt; e = header.next; e != header; e = e.next)
13        clone.add(e.element);
14     return clone;
15 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>调用父类的clone()方法初始化对象链表clone，将clone构造成一个空的双向循环链表，之后将header的下一个节点开始将逐个节点添加到clone中。最后返回克隆的clone对象。</p>
<p>toArray()</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre>1 public Object[] toArray() {
2     Object[] result = new Object[size];
3     int i = 0;
4     for (Entry&lt;E&gt; e = header.next; e != header; e = e.next)
5         result[i++] = e.element;
6     return result;
7 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>创建大小和LinkedList相等的数组result，遍历链表，将每个节点的元素element复制到数组中，返回数组。</p>
<p>toArray(T[]&nbsp;a)</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre> 1 public &lt;T&gt; T[] toArray(T[] a) {
 2     if (a.length &lt; size)
 3         a = (T[])java.lang.reflect.Array.newInstance(
 4                                a.getClass().getComponentType(), size);
 5     int i = 0;
 6     Object[] result = a;
 7     for (Entry&lt;E&gt; e = header.next; e != header; e = e.next)
 8         result[i++] = e.element;
 9     if (a.length &gt; size)
10         a[size] = null;
11     return a;
12 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>先判断出入的数组a的大小是否足够，若大小不够则拓展。这里用到了发射的方法，重新实例化了一个大小为size的数组。之后将数组a赋值给数组result，遍历链表向result中添加的元素。最后判断数组a的长度是否大于size，若大于则将size位置的内容设置为null。返回a。</p>
<p>从代码中可以看出，数组a的length小于等于size时，a中所有元素被覆盖，被拓展来的空间存储的内容都是null；若数组a的length的length大于size，则0至size-1位置的内容被覆盖，size位置的元素被设置为null，size之后的元素不变。</p>
<p>为什么不直接对数组a进行操作，要将a赋值给result数组之后对result数组进行操作？</p>
<p><strong>9、遍历数据：Iterator()</strong></p>
<p>LinkedList的Iterator</p>
<p>除了Entry，LinkedList还有一个内部类：ListItr。</p>
<p>ListItr实现了ListIterator接口，可知它是一个迭代器，通过它可以遍历修改LinkedList。</p>
<p>在LinkedList中提供了获取ListItr对象的方法：listIterator(int&nbsp;index)。</p>
<pre>1 public ListIterator&lt;E&gt; listIterator(int index) {
2     return new ListItr(index);
3 }</pre>
<p>该方法只是简单的返回了一个ListItr对象。</p>
<p>LinkedList中还有通过集成获得的listIterator()方法，该方法只是调用了listIterator(int&nbsp;index)并且传入0。</p>
<p>二、ListItr</p>
<p>下面详细分析ListItr。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre>  1 private class ListItr implements ListIterator&lt;E&gt; {
  2 // 最近一次返回的节点，也是当前持有的节点
  3     private Entry&lt;E&gt; lastReturned = header;
  4     // 对下一个元素的引用
  5     private Entry&lt;E&gt; next;
  6     // 下一个节点的index
  7     private int nextIndex;
  8     private int expectedModCount = modCount;
  9     // 构造方法，接收一个index参数，返回一个ListItr对象
 10     ListItr(int index) {
 11         // 如果index小于0或大于size，抛出IndexOutOfBoundsException异常
 12         if (index &lt; 0 || index &gt; size)
 13         throw new IndexOutOfBoundsException("Index: "+index+
 14                             ", Size: "+size);
 15         // 判断遍历方向
 16         if (index &lt; (size &gt;&gt; 1)) {
 17         // next赋值为第一个节点
 18         next = header.next;
 19         // 获取指定位置的节点
 20         for (nextIndex=0; nextIndex&lt;index; nextIndex++)
 21             next = next.next;
 22         } else {
 23 // else中的处理和if块中的处理一致，只是遍历方向不同
 24         next = header;
 25         for (nextIndex=size; nextIndex&gt;index; nextIndex--)
 26             next = next.previous;
 27        }
 28    }
 29     // 根据nextIndex是否等于size判断时候还有下一个节点（也可以理解为是否遍历完了LinkedList）
 30     public boolean hasNext() {
 31         return nextIndex != size;
 32    }
 33     // 获取下一个元素
 34     public E next() {
 35        checkForComodification();
 36         // 如果nextIndex==size,则已经遍历完链表，即没有下一个节点了（实际上是有的，因为是循环链表，任何一个节点都会有上一个和下一个节点，这里的没有下一个节点只是说所有节点都已经遍历完了）
 37         if (nextIndex == size)
 38         throw new NoSuchElementException();
 39         // 设置最近一次返回的节点为next节点
 40         lastReturned = next;
 41         // 将next“向后移动一位”
 42         next = next.next;
 43         // index计数加1
 44         nextIndex++;
 45         // 返回lastReturned的元素
 46         return lastReturned.element;
 47    }
 48
 49     public boolean hasPrevious() {
 50         return nextIndex != 0;
 51    }
 52     // 返回上一个节点，和next()方法相似
 53     public E previous() {
 54         if (nextIndex == 0)
 55         throw new NoSuchElementException();
 56
 57         lastReturned = next = next.previous;
 58         nextIndex--;
 59        checkForComodification();
 60         return lastReturned.element;
 61    }
 62
 63     public int nextIndex() {
 64         return nextIndex;
 65    }
 66
 67     public int previousIndex() {
 68         return nextIndex-1;
 69    }
 70     // 移除当前Iterator持有的节点
 71     public void remove() {
 72            checkForComodification();
 73             Entry&lt;E&gt; lastNext = lastReturned.next;
 74             try {
 75                 LinkedList.this.remove(lastReturned);
 76             } catch (NoSuchElementException e) {
 77                 throw new IllegalStateException();
 78            }
 79         if (next==lastReturned)
 80                 next = lastNext;
 81             else
 82         nextIndex--;
 83         lastReturned = header;
 84         expectedModCount++;
 85    }
 86     // 修改当前节点的内容
 87     public void set(E e) {
 88         if (lastReturned == header)
 89         throw new IllegalStateException();
 90        checkForComodification();
 91         lastReturned.element = e;
 92    }
 93     // 在当前持有节点后面插入新节点
 94     public void add(E e) {
 95        checkForComodification();
 96         // 将最近一次返回节点修改为header
 97         lastReturned = header;
 98        addBefore(e, next);
 99         nextIndex++;
100         expectedModCount++;
101    }
102     // 判断expectedModCount和modCount是否一致，以确保通过ListItr的修改操作正确的反映在LinkedList中
103     final void checkForComodification() {
104         if (modCount != expectedModCount)
105         throw new ConcurrentModificationException();
106    }
107 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>下面是一个ListItr的使用实例。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre> 1 LinkedList&lt;String&gt; list = new LinkedList&lt;String&gt;();
 2         list.add("First");
 3         list.add("Second");
 4         list.add("Thrid");
 5        System.out.println(list);
 6         ListIterator&lt;String&gt; itr = list.listIterator();
 7         while (itr.hasNext()) {
 8            System.out.println(itr.next());
 9        }
10         try {
11             System.out.println(itr.next());// throw Exception
12         } catch (Exception e) {
13             // TODO: handle exception
14        }
15         itr = list.listIterator();
16        System.out.println(list);
17        System.out.println(itr.next());
18         itr.add("new node1");
19        System.out.println(list);
20         itr.add("new node2");
21        System.out.println(list);
22        System.out.println(itr.next());
23         itr.set("modify node");
24        System.out.println(list);
25        itr.remove();
26         System.out.println(list);</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre> 1 结果：
 2 [First, Second, Thrid]
 3 First
 4 Second
 5 Thrid
 6 [First, Second, Thrid]
 7 First
 8 [First, new node1, Second, Thrid]
 9 [First, new node1, new node2, Second, Thrid]
10 Second
11 [First, new node1, new node2, modify node, Thrid]
12 [First, new node1, new node2, Thrid]</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>LinkedList还有一个提供Iterator的方法：descendingIterator()。该方法返回一个DescendingIterator对象。DescendingIterator是LinkedList的一个内部类。</p>
<pre>1 public Iterator&lt;E&gt; descendingIterator() {
2    return new DescendingIterator();
3 }</pre>
<p>下面分析详细分析DescendingIterator类。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<pre> 1 private class DescendingIterator implements Iterator {
 2    // 获取ListItr对象
 3 final ListItr itr = new ListItr(size());
 4 // hasNext其实是调用了itr的hasPrevious方法
 5    public boolean hasNext() {
 6        return itr.hasPrevious();
 7    }
 8 // next()其实是调用了itr的previous方法
 9    public E next() {
10        return itr.previous();
11    }
12    public void remove() {
13        itr.remove();
14    }
15 }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></p>
<p>从类名和上面的代码可以看出这是一个反向的Iterator，代码很简单，都是调用的ListItr类中的方法。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 16:55:36 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/nbsp/" title="nbsp">nbsp</a>, <a href="https://www.biecuoliao.com/tag/handle/" title="handle">handle</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.biecuoliao.com/tag/result/" title="result">result</a>, <a href="https://www.biecuoliao.com/tag/cond/" title="cond">cond</a>, <a href="https://www.biecuoliao.com/tag/intern/" title="intern">intern</a>, <a href="https://www.biecuoliao.com/tag/%e4%b8%8d%e5%bf%85%e8%a6%81/" title="不必要">不必要</a>, <a href="https://www.biecuoliao.com/tag/pyc/" title="pyc">pyc</a>, <a href="https://www.biecuoliao.com/tag/%e6%8f%92%e5%85%a5%e5%af%b9%e8%b1%a1/" title="插入对象">插入对象</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java集合---LinkedList源码解析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoNXWb4.html" rel="bookmark">java集合类型源码解析之PriorityQueue</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本来第二篇想解析一下LinkedList,不过扫了一下源码后,觉得LinkedList的实现比较简单,没有什么意思,于是移步PriorityQueue. PriorityQueue通过数组实现了一个堆数据结构(相当于一棵完全二叉树),元素的优先级可以通过一个Comparator来计算,如果不指定Comparator,那么元素类型应该实现Comparable接口.最终compare得出的最小元素,放在堆的根部. 成员变量 public class PriorityQueue&lt;E&gt; extends			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Q6QgeM.html" rel="bookmark">Java集合-09LinkedHashMap源码解析及使用实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				LinkedHashMap 简介 hash表和链表实现了map接口,迭代顺序是可以预测的.LinkedHashMap和HashMap的不同是它所有的entry 维持了一个双向链表结构.该链表定义了通常迭代顺序是键插入的顺序. LinkedHashMap 定义 public class LinkedHashMap&lt;K,V&gt; extends HashMap&lt;K,V&gt; implements Map&lt;K,V&gt; 继承HashMap类,表明对于HashMap的操作LinkedHas			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35dmjE0.html" rel="bookmark">【java集合框架源码剖析系列】java源码剖析之TreeMap</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				注:博主java集合框架源码剖析系列的源码全部基于JDK1.8.0版本.本博客将从源码角度带领大家学习关于ArrayList的知识. 一TreeMap的定义: public class TreeMap&lt;K,V&gt; extends AbstractMap&lt;K,V&gt; implements NavigableMap&lt;K,V&gt;, Cloneable, java.io.Serializable 可以看到TreeMap是继承自AbstractMap同时实现了NavigableMap,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWKAoLM.html" rel="bookmark">Java集合框架源码阅读之AbstractCollection</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				AbstractCollection是集合实现类的根抽象实现类,它实现了Collection接口,集合中的三个分支Set.List.Queue都是继承此类之后再进行各自实现的扩展,分别是AbstractSet.AbstractList.AbstractQueue.这三个分支有一些共同之处,需要用一些共同的方法,因此出现了AbstractCollection类,它包含了一些这三个分支都会用到的常用方法.而这三个分支也各有抽象类,因为这三个分支下面的一些具体实现也会有一些当前分支通用的方法,因此也给			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBkjAJ0.html" rel="bookmark">【Java集合】-- LinkedList源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 继承体系 数据结构 源码解析 1.属性 2.构造方法 LinkedList() LinkedList(Collection&lt;? extends E&gt; c) 3.添加元素 add(E e) addFirst(E e) addLast(E e) add(int index, E element) offer(E e) offerFirst(E e) offerLast(E e) 总结 4.获取元素 get(int index) getFirst() getLast() peek() 5.删除			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgNjX84.html" rel="bookmark">Java集合框架之二：LinkedList源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				版权声明:本文为博主原创文章,转载请注明出处,欢迎交流学习! LinkedList底层是通过双向循环链表来实现的,其结构如下图所示: 链表的组成元素我们称之为节点,节点由三部分组成:前一个节点的引用地址.数据.后一个节点的引用地址.LinkedList的Head节点不包含数据,每一个节点对应一个Entry对象.下面我们通过源码来分析LinkedList的实现原理. 1.Entry类源码: 1 private static class Entry&lt;E&gt; { 2 E element; 3 Entr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41aZNY4.html" rel="bookmark">Java 集合Vector源码深入解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概论 学完ArrayList和LinkedList之后,我们接着学习Vector.学习方式还是和之前一样,先对Vector有个整体认识,然后再学习它的源码:最后再通过实例来学会使用它. 第1部分 Vector介绍 Vector简介 Vector 是矢量队列,它是JDK1.0版本添加的类.继承于AbstractList,实现了List, RandomAccess, Cloneable这些接口.Vector 继承了AbstractList,实现了List:所以,它是一个队列,支持相关的添加.删除.修			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41BadYM.html" rel="bookmark">【Java深入研究】2、LinkedList源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.源码解析 1. LinkedList类定义. public class LinkedList&lt;E&gt; extends AbstractSequentialList&lt;E&gt; implements List&lt;E&gt;, Deque&lt;E&gt;, Cloneable, java.io.Serializable LinkedList 是一个继承于AbstractSequentialList的双向链表.它也可以被当作堆栈.队列或双端队列进行操作.LinkedList 实现 Li			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLOJEe4.html" rel="bookmark">Java 集合Hashtable源码深入解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概要 前面,我们已经系统的对List进行了学习.接下来,我们先学习Map,然后再学习Set:因为Set的实现类都是基于Map来实现的(如,HashSet是通过HashMap实现的,TreeSet是通过TreeMap实现的). 首先,我们看看Map架构.如上图:(01) Map 是映射接口,Map中存储的内容是键值对(key-value).(02) AbstractMap 是继承于Map的抽象类,它实现了Map中的大部分API.其它Map的实现类可以通过继承AbstractMap来减少重复编码.(			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/7MVQby4.html" rel="bookmark" class="title">020&num; Adempiere的会计功能模组（一）</a>
					<div>
						在Adempiere系统中会计和生产是它的核心部分,其中会计贯彻了整个ERP系统,构建起环环相扣.处处相连的商业管理模型.将系统的各个功能模组诸如:业务伙伴.系统银行账户.现金账户.物料产品价格.工程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMPEDP0.html" rel="bookmark" class="title">HDU-1878   判断无向图欧拉回路，水</a>
					<div>
						HDU 1878 题意:问一个无向图是否存在欧拉回路. 总结: 1.一个无向图存在欧拉回路,当且仅当该图所有顶点度数都为偶数,且该图是连通图.2.一个有向图存在欧拉回路,所有顶点的入度等于出度且该图是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBmjrA4.html" rel="bookmark" class="title">shell脚本学习笔记之sed命令用法</a>
					<div>
						sed基本用法 sed:stream editor 行编辑器 sed:模式空间 将匹配的文本内容储存到模式空间中 默认不编辑原文件,仅对模式空间中的数据做处理,而后,处理结束后,架构模式空间的内容显示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvley0.html" rel="bookmark" class="title">IOS实现多媒体音频之音乐播放器</a>
					<div>
						随着智能手机市场越来越活跃,相应的app也变得五彩缤纷,各式各样,让你的app更吸引人多媒体技术不可避免.通过对音频和视频等控制让你的app更加丰富多彩,今天和大家一起研究下基本的音频使用.本文只提供 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YgxPJ4.html" rel="bookmark" class="title">阿里巴巴2018届应届生模拟考试题</a>
					<div>
						题目 小猴子下山,沿着下山的路由一排桃树,每棵树都结了一些套子.小猴子想摘桃子,但是有一些条件需要遵守,小猴子只能沿着下山的方向走,不能回头,每棵树最多摘一个,而且一旦摘了一棵树的桃子,就不能再摘比这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wv9LV0.html" rel="bookmark" class="title">添加到购物车</a>
					<div>
						private void doAddCar() { // 1.获取商品bid int bid = getInt(&quot;id&quot;); // 2.获取购物车 List&lt;BookInfo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGv2bM.html" rel="bookmark" class="title">关于无法完全下载CyanogenMod代码的问题</a>
					<div>
						CyanogenMod真的是一个神奇的东东,它让开发手机固件不再是手机生产商的专利,每个有志于此的程序员都可能为自己的手机定制一份专有的,独一无二的固件,这在以前是想都不敢想的.并且CyanogenM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5PAE0.html" rel="bookmark" class="title">HAProxy的三种不同类型配置方案</a>
					<div>
						haproxy是一款功能强大.灵活好用反向代理软件,提供了高可用.负载均衡.后端服务器代理的功能,它在7层负载均衡方面的功能很强大(支持cookie track, header rewrite等等), ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPDqByM.html" rel="bookmark" class="title">设置MYSQL允许用IP访问</a>
					<div>
						2012-01-10 14:43 55人阅读 评论(0) 收藏 举报SQL Error (1130): Host '192.168.1.100' is not allowed to connect t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kplJP3.html" rel="bookmark" class="title">Android自动检测版本及自动升级</a>
					<div>
						步骤: 1.检测当前版本的信息AndroidManifest.xml--&gt;manifest--&gt;android:versionName. 2.从服务器获取版本号(版本号存在于xml文件中) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/478z7xM.html" rel="bookmark" class="title">java泛型数组</a>
					<div>
						转载自http://blog.csdn.net/orzlzro/article/details/7017435 Java 不支持泛型数组.也就是说, List&lt;String&gt;[] ls = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dNLRZ4.html" rel="bookmark" class="title">进程相关函数-exec等</a>
					<div>
						1. exec函数 #include&lt;unistd.h&gt; int execl(const char *pathname,const char *arg,...); int execlp(c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nq9rG3.html" rel="bookmark" class="title">YII访问数据库&lpar;Yii Dao&rpar;</a>
					<div>
						CDbConnection: 一个抽象数据库连接CDbCommand: SQL statementCDbDataReader: 匹配结果集的一行记录CDbTransaction:数据库事务 访问数据库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qxY9D0.html" rel="bookmark" class="title">asp&period;net core 简单部署</a>
					<div>
						目的 练习asp.net core的技术使用.部署等.目前拥有一台阿里云服务器(超级低配版本),安装了centos系统,打算将练习项目发布到该环境中.可能需要做以下准备工作. 以前没接触过linux正 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5zQQ3.html" rel="bookmark" class="title">Html样式布局复习</a>
					<div>
						&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZkBN4.html" rel="bookmark" class="title">数组相关函数</a>
					<div>
						数组验证码: ????将验证码中所使用到的数据,用数组的形式组织出来. 1.生成验证码所需的数据 示例: 2.将数组中的元素位置打乱 shuffle(); 示例: 3.随机获取元素 array_ran ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QjO6NM.html" rel="bookmark" class="title">单片机串口通信技术</a>
					<div>
						串口通信 随着多微机系统的广泛应用和计算机网络技术的普及,计算机的通信功能愈来愈显得重要.计算机通信是指计算机与外部设备或计算机与计算机之间的信息交换. 通信有并行通信和串行通信两种方式.在多微机系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wB8OV0.html" rel="bookmark" class="title">设计模式学习笔记&mdash;&mdash;外观模式</a>
					<div>
						1.特点:子系统的高层接口,避免两个类直接关系的第三者. 2.概念:为子系统中的一组接口提供一个一致的界面,此模式定义了一个高层接口,这个接口使得这一子系统更加容易使用. 3.类图: 4.程序实现:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVv1DzM.html" rel="bookmark" class="title">select添加皮肤 jquery</a>
					<div>
						由于select修改样式不能兼容浏览器,也不能随意修改,那么就需要模拟select,给select添加皮肤了,代码如下 &lt;!DOCTYPE html&gt; &lt;html lang=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBy9k4.html" rel="bookmark" class="title">&lbrack;LeetCode&rsqb;Remove Duplicates from Sorted Array2</a>
					<div>
						题意:从有序数组中删除重复数据,但是与题目一有一点区别:可以允许重复一次 思路:首先判断是否重复,有的话指针后移,然后按照题1中的思路进行,复杂度O(N) 代码: public int removeD ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
